SystemOrganization addCategory: #Smutty!
SystemOrganization addCategory: 'Smutty-Tests'!
SystemOrganization addCategory: 'Smutty-Web'!
SystemOrganization addCategory: 'Smutty-Web-Tests'!

TestCase subclass: #QuestStateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!QuestStateTest commentStamp: '<historical>' prior: 0!
A QuestStateTest is a test class for testing the behavior of QuestState!

!QuestStateTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 07:41'!
test_01_advancingTheQuest
	| quest questState questAdvancer action |
	
	quest := StoryMap example.
	questState := QuestState on: quest.
	questAdvancer := QuestAdvancer new.
	action := QuestAction description: 'Win!!'.
	
	self assert: questState currentNode = quest nodes first.
	questAdvancer advance: questState with: action.
	self assert: questState currentNode = quest nodes last.! !

TestCase subclass: #StoryMapHtmlRendererTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web-Tests'!

!StoryMapHtmlRendererTest commentStamp: 'SergioFedi 6/5/2015 23:34' prior: 0!
A StoryMapHtmlRendererTest is a test class for testing the behavior of StoryMapHtmlRenderer!

!StoryMapHtmlRendererTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 6/6/2015 00:28'!
test_01_basicUsage

	| renderer filesystem |
	filesystem := FileSystem memory.
	renderer := StoryMapHtmlRenderer new.
	renderer filesystem: filesystem.
	renderer outputDirectory: 'SmuttyTest'.
	renderer htmlName: 'testStory'.
	renderer storyMap: StoryMap example.
	renderer render.
	self assert: (filesystem exists: 'SmuttyTest:testStory.html').
	self assert: (filesystem exists: 'SmuttyTest:testStory_node_1.html').
	self assert: (filesystem exists: 'SmuttyTest:testStory_node_2.html').


! !

!StoryMapHtmlRendererTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 6/6/2015 00:30'!
test_02_defaultFilesystem

	| renderer |
	renderer := StoryMapHtmlRenderer new.
	self assert: (renderer filesystem class = FileReference).
! !

TestCase subclass: #StoryMapMarkdownRendererTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web-Tests'!

!StoryMapMarkdownRendererTest commentStamp: '<historical>' prior: 0!
A StoryMapMarkdownRendererTest is a test class for testing the behavior of StoryMapMarkdownRenderer!

!StoryMapMarkdownRendererTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/19/2015 07:43'!
test_01_basicUsage
| aStoryMap markdownText renderer |
aStoryMap := StoryMap example.
renderer := StoryMapMarkdownRenderer on: aStoryMap.
markdownText := renderer render.

self assert: markdownText notNil.
self assert: markdownText equals: 
'# Name1
Welcome to the game. It''s super hot. Wear mittens!!

[Win!!](Name2)

# Name2
You''ve won the game. You should be proud. We hope you enjoyed the lack of any erotic content.
'.! !

TestCase subclass: #StoryMapTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryMapTest commentStamp: '<historical>' prior: 0!
A StoryMapTest is a test class for testing the behavior of StoryMap!

!StoryMapTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 6/5/2015 20:59'!
test_01_example

	| story |
	story := StoryMap example.
	self assert: story beginning notNil.
	self assert: story nodes notEmpty.
	self assert: story transitions notEmpty.! !

TestCase subclass: #StoryNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryNodeTest commentStamp: '<historical>' prior: 0!
A StoryNodeTest is a test class for testing the behavior of StoryNode!

!StoryNodeTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 6/6/2015 00:17'!
test_01_creation

	| node |
	node := StoryNode new.
	self assert: node text isNil.
	node text: 'test'.
	self assert: node text = 'test'.! !

!StoryNodeTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 6/18/2015 06:42'!
test_02_textParsing

	| node |
	node := StoryNode new.
	self assert: node text isNil.
	self assert: node paragraphs isNil.
	node text: 'Paragraph 1 should be followed by two line breaks.

Paragraph 2 is the following text'.

	self assert: node paragraphs size = 2.
	self assert: node paragraphs first = 'Paragraph 1 should be followed by two line breaks.'.
	self assert: node paragraphs second = 'Paragraph 2 is the following text'.! !

TestCase subclass: #StoryTransitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryTransitionTest commentStamp: '<historical>' prior: 0!
A StoryTransitionTest is a test class for testing the behavior of StoryTransition!

!StoryTransitionTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 08:00'!
test_01_actionDescription
	| transition placeholderOrigin placeholderDestination |
	
	placeholderOrigin := nil.
	placeholderDestination := nil.
	transition := StoryTransition origin: placeholderOrigin destination: placeholderDestination actionDescription: 'Win!!'. 
	
	self assert: (transition actionDescription = 'Win!!').! !

WAFileLibrary subclass: #SmuttyLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

WAComponent subclass: #SmuttyWebApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!SmuttyWebApp methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/16/2015 07:51'!
renderContentOn: html
	html heading with: 'Hola Manola'.! !

WASession subclass: #SmuttySession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

Object subclass: #QuestAction
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!QuestAction commentStamp: 'SergioFedi 6/5/2015 20:45' prior: 0!
I model an action that can be taken in the context of a quest or that is relevant to a quest (or quests, in general).!

!QuestAction class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/3/2015 07:43'!
description: aString 
	^ self new description: aString.! !

!QuestAction methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:48'!
description
	^ description.! !

!QuestAction methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 07:43'!
description: aString 
	description := aString.! !

Object subclass: #QuestAdvancer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!QuestAdvancer commentStamp: 'SergioFedi 6/5/2015 21:00' prior: 0!
This class does not model anything, it's just here for research purposes.!

!QuestAdvancer methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 08:04'!
advance: aQuestState with: anAction 
	| relevantTransitions advancingTransitions advancingTransition |
	
	relevantTransitions := aQuestState quest transitionsFrom: aQuestState currentNode.
	advancingTransitions := relevantTransitions select: [ :each | each actionDescription = anAction description ].
	advancingTransition := advancingTransitions first.
	
	aQuestState currentNode: advancingTransition destination.! !

Object subclass: #QuestState
	instanceVariableNames: 'quest currentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!QuestState commentStamp: 'SergioFedi 6/5/2015 20:44' prior: 0!
I model a mobile point in the story-space.
That is, where/how I am withing a story.
More speciffically, a Quest.
!

!QuestState class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/10/2015 07:10'!
on: aQuestMap 
	^ self new quest: aQuestMap.! !

!QuestState methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 06:54'!
currentNode
	^ currentNode.! !

!QuestState methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 07:05'!
currentNode: aStoryNode 
	currentNode := aStoryNode.! !

!QuestState methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:23'!
quest
	^ quest.! !

!QuestState methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 07:04'!
quest: aStoryMap 
	quest := aStoryMap.
	self currentNode: aStoryMap beginning.! !

Object subclass: #StoryMap
	instanceVariableNames: 'nodes beginning transitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!StoryMap commentStamp: 'FedericoFigueredo 6/1/2015 07:36' prior: 0!
StoryMap se define como el conjunto de pedacitos de ficción/historia y las formas en las que estos se relacionan entre si.!

!StoryMap class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/23/2015 07:19'!
dansExample
	| map 
	introductionNode 
	genderMaleNode 
	genderFemaleNode 
	maleScene1Node 
	femaleScene1Node 
	maleScene2Node 
	femaleScene2Node 
	maleScene3Node 
	femaleScene3Node 
	maleScene4Node 
	femaleScene4Node 
	theEndNode |
	map := StoryMap new.	"Defined nodes: Introduction is the start of the story, the main bulk, Gendermale and Genderfemale and their accompanying scene nodes are the only options right now, and based on which you pick you’ll get a different story."
	introductionNode := StoryNode
		text:
			'You grimace and hop backwards until you’re leant against the wall, just in time to avoid the murky puddle kicked up by a passing car. You nearly trip over your shopping bag as you pick up the pace; it’ll rain again pretty soon.

And it’s never good to be caught in the rain, it’s so toxic it cuts a few years off.

As you reach your apartment block, a deep rumble in the clouds cast your eyes upwards, skyscrapers pierce the clouds, and neon signs blare with enough strength to give you a headache.

Apparently things used to be better, but you’re pretty sure you’ve never even seen a for real no-fucking-kidding tree around here in the corporate hub. There used to be job prospects, and more to life than the net.

Not that you mind the net, you push open the rusty entrance to your block, and duck in just as the rain begins to fall. The lift ahead is out; you heft the weight of the bag in your hand, reluctantly climbing the stairs. As you pass one of the rooms on the way up, you can hear what’s either a couple going at it, or someone has their porn too loud.

You steel yourself and carry on before you’re caught outside listening in. Eventually you reach your own door, panting for breath.

The Corporations may have let the buildings around them decline into a grim old shit hole, but you at least try to keep the place tidy… Well, tidy-ish. At least you don’t seem to have any rodents. After all, it’s a small studio; you’ve got the means to live, a little bathroom, and on the other side of the room, completely at odds with your basic furniture, rests a beautiful box of polished chrome.

You feel a swell of pride in your stomach at the sheer sight of your beloved beast. You can practically feel the net-jack behind your ear grow warm in anticipation. It’s all you can do to unpack your shopping; admittedly it’s nothing but instant ramen, energy drinks, and coffee. But that stuff can be heavy.

You go through the process of throwing off your gross street-clothes and pulling on something comfy. You take a look in the mirror just as you toss your jacket into the corner, eyeing yourself up. But what are you?'.
	genderMaleNode := StoryNode
		text:
			'You’re a guy, and you’re packing the cock to prove it at least. You give yourself a once-over as you turn around in the mirror and tug on a shirt and some baggy jeans. How do you look?'.
	genderFemaleNode := StoryNode
		text:
			'You’re a girl, with the breasts and pussy to prove it at the least. You give yourself a once-over as you turn around in the mirror and tug on a shirt and some baggy jeans. How do you look?'.
	maleScene1Node := StoryNode
		text:
			'You’re proud to prove malnutrition and science wrong with your toned body, no matter what you put away you’ve always seemed to possess some muscle density and clean features.

You flash yourself the finger pistols. If your mother were still about she’d scold you for looking lazy. But it’s your place!! You paid for it with your own hard earned cash.

Well, mostly hard-earned. You’re just about paying the bills and not dying of starvation. You’ve found that poking at the less ‘Iced’ parts of corporate nets will give you enough information to sell for a living. It’s not risk free of course, but you’ve yet to have suits crash in to your home and mysteriously disappear you.

You drop in to your chair, sighing as you feel it practically hug your buns. You stare at the machine before you; a beautiful box of technology. Along the bottom of it, drawn on in your own scribbly hand, is the ink drawing of an animal.'.
	femaleScene1Node := StoryNode
		text:
			'You’ve always been undeniably curvy, the calories only go to your favourite bits. Mother would be so proud.

You flash yourself the finger pistols. But if your mother were still about she’d also scold you for looking lazy. But it’s your place!! You paid for it with your own hard earned cash.

Well, mostly hard-earned. You’re just about paying the bills and not dying of starvation. You’ve found that poking at the less ‘Iced’ parts of corporate nets will give you enough information to sell for a living. It’s not risk free of course, but you’ve yet to have suits crash in to your home and mysteriously disappear you.

You drop in to your chair, sighing as you feel it practically hug your buns. You stare at the machine before you; a beautiful box of technology. Along the bottom of it, drawn on in your own scribbly hand, is the ink drawing of an animal.'.
	maleScene2Node := StoryNode
		text:
			'Ah the faithful dog. Resilient and loyal. You slide a cord from the side of your computer, stroking the jack with your fingers. You take a soft breath, holding it in. It’s always felt like this, deep down inside; a churning in your stomach right before you hook up.

The moment the jack of the cord meets the one behind your ear, your hands fall into your lap. The breath you hold escapes in a yawn as you sink into the warm embrace of data. Your body grows warm, and the churning in your stomach settles to a calm sea.

You open eyes you didn’t even realise had even closed, and look about yourself. All around is the architecture of your computer; it always looks like a richly furnished lounge, surrounded by obelisks of processing and data. It has always felt like your real home; your fortress.

You feel that fortress look you over, cautiously. That’s your own fault; you made sure to keep the Beast paranoid. You don’t always encounter the friendliest types when you make a living hacking big scary corps. After a few moments, a door opens, and you feel yourself being pulled inside like an old friend who hasn’t visited in months.

You could start some games from here, but there’s only one thing you’re really interested in doing in your time off.

You feel a presence at your feet, and crouch, hands spreading wide. A jet black Husky dog all but pounces on you, licking at your neck. It feels real enough, every sensation of your body is cranked up to eleven when you’re jacked into a computer. After a little, the dog settles back, wolfy features and eyes quite literally glowing with intelligence.

“Welcome back Master” it seems to say, the words echoing in your head with warmth. You grin and point at a door, and the Beast pads its way over, tail wagging.

“We’re going for a walkies” you say proudly. It’s a joke you never get tired of telling. The door seems to sit at the end of your lounge, and it’s the entrance to the net itself. It’s impossible to traverse with just your own intelligence. Humans aren’t made to cope with that density of information. Once you’re on a server it’s no problem, you can adjust. But in order to get from one to the other. You need a companion.

You smile fondly at the Beast, opening the door and jumping in to the white light that shines out. The Beast follows after you, leaping into the opening. For a brief, panic-ridden moment you’re afloat in a cascade of numbers. But you feel the invisible leash of your companion around your wrist, and the world goes still.

Instead there are tunnels, tunnels to endless possibilities. At the speed of thought you’re hurtling down tubes connected to polyhedrons of various faces. You take the familiar bookmarked routes, and the white light swaps to a pitch blackness. It used to be scary, but you’ve done it so often it’s even easier than breathing.

You jump through a few proxies, and in what feels like a minute on the net, you know only seconds have passed in reality. You reach the next proxy and pause. You can feel it deep down, and the Beast confirms it. You press your hands against a sheet black surface, like polished obsidian in a tunnel of nothing. 

Your entire body seems to glitch as you lag for the barest few moments. Your breath catches, and then  a crack spreads in the wall. You knock, it’s only polite, and the wall shatters, turning into a door that you step through, the Beast on your heels.

And now you’re in the hub of humanity’s greatest depravities. Heck, by this point you’ve probably taken part in most of them.

What looks like a man of twenty, with the ears of a dog, steps out in front of you.

“Greetings sir, do you have a login?”

You’re a little caught off guard, and stumble, back. But you confirm that you do, and a moment later the man grins. His official demeanour slips as his own UI likely confirms you, and you even catch the hint of a tail wagging.

“Cheers buddy. I hate playing strongarm. I know, I know. This is no Light-net authenticated user bollocks, but there’ve been some weird sorts about”

You look around, and watch twenty mice pour out of a casino, before bursting into flames. Nooby hackers never learn. The dogman follows your gaze and chuckles.

“I know!! Weird even for here. But seriously, I mean it. I hear we’ve got Pirates. And not the kind that can score raunchy flicks, but the Black-Ops information hustling kind. Rumour says they’ve even got some dudes working in meatspace ganking anyone who tries to figure them out. So yeah, authenticated people only for now, we don’t need that kinda flak”.

You’re about to ask him for more information, but the Dog-Man’s ears twitch, and you hear a pinging noise.

“Sorry buddy, gotta bounce. There’s a sexy slice of puss with this pup’s name on it”

He waves apologetically and scampers off. Next stop, you suppose. You take a moment to look over the whole hub. It’s a central point for people on the Dark Net. a Corporation-free haven for the info-trade. Well, mostly corp free. You know they’ve got men on the inside, but you’ve yet to meet one.

On the net your body has needs, and can feel all the sensations. There’s no end of sex-trade, alcohol-drinking, and monster fighting to get up to. Sometimes they’re all the same at once, the Dark Net gets pretty dangerous. You head towards an information board and look up news on these new Pirates though.

It takes a little browsing, most of the information is bunk rumour-mongering, but this is the kind of thing you’re trained in taking apart. Eventually you find a node that’s seen a lot more action. You find a proxy door, and head out, with the Beast at your side.

Instead of another hub town, you find yourself with an open field. You’re sure this isn’t right, you were looking for some kind of base of operations, or at the least a busy info-bar. But this is a straight-up fantasy field.

“Oi!!” calls a thickly accented voice.

Your Beast growls, hackles rising. You turn to meet the voice, already thinking of ways to defend yourself. Instead of some kind of poorly dressed internet-pirate, you’re faced with a stunning visage in a black skintight bodysuit. Your brain almost can’t register their gender but the mere sight of them sends your sex drive skyrocketing in to uncontrollable heights.'.
	maleScene3Node := StoryNode
		text:
			'It’s a guy, it couldn’t be anything but a guy. His skin is of purest obsidian, his ears are elfin, and though his features are feminine, you can see the bulge against his pants. There must be eight inches of the monster there, and your eyes are caught between staring at it or being lost in the stranger’s own eyes.

You take a deep breath and try to speak, but the man holds his finger to his lips in a soft “Shh” and your body falls still. You’re fairly certain something’s been done to you, none of your limbs are moving.

“Now that I have your undivided attention. Please, do remain still and let me take a good look at you”

You’re not sure how to react, but it’s hard to focus as the man takes step after step closer to you. He looks down at your dog however, and sighs. He sweeps his hand and the Beast is dispersed like dust in the wind.

This sets off alarm bells in your head and you try to run; you’re a sitting duck without your UI and somehow they’ve been separated from you. Your body refuses to answer your call to motion. You’re bound by nothingness, as though sealed in stone. You are, however, growing rock hard. You’re not sure if you can blame that on hacking or your own net-enhanced sensations. 

You look up and gulp, heat rushing to your cock as your body breaks out in a flush. The mystery man is close enough that your noses are almost touching. He runs his hands through your hair and hauls you into an aggressive kiss. His tongue forces your mouth open and explores. Your hair is tugged back on and you’re entirely at his whims. Every overactive nerve in your body is sent into overdrive as you struggle to keep up with the assault on your senses.

You feel nails dig into your chest, and your clothes are torn away, your manhood is hard, blood rushing through it with a purpose. Every part of you is begging for another touch as the man steps back. He draws his fingers through his short blonde hair, and deep purple eyes rend a hole through your being.

“You’re looking for us” he says.

You struggle to take in the information, mumbling a weak “pardon?” before he pushes you over. You fall on to your rear and he leans over.

“I said, you’re looking for us. Our group. You think we don’t have anyone keeping an eye out?”

He sighs and drops to his knees, hands wrapping around your cock. It’s all a surprise, and you don’t know how to react. It’s only a few moments of vicious jerking and you coat his palm in spunk, your entire being trembling with the force of the orgasm.

You’ve never felt so helpless, and the man shakes his hand out, flicking your own spunk on to your body as he bends down.

“Sorry, it’s time for you to taste a little reality” he says, licking the rest of his hand clean.

The entire time you’ve been unable to muster a single word, but everything reboots before you can form a word.

In a moment of bleak nothing, you find yourself in meatspace, your real body is sprawled out on the floor. Your data jack is dangling from your computer with no home, and the port behind your ear feels like it’s burning.

A resounding crash draws your attention to your door. Two men in suits are kicking their way in, and they look over you. Your baggy shirt is glued to your stomach with cum, and you can’t move a single limb of your body. Instead of words, you’re forced to hold back the need to throw up.

“Sorry” one of them says as they haul you up and you begin to black out again.'.
	maleScene4Node := StoryNode
		text:
			'It’s a woman. It couldn’t be anything but. She must have double F cups and her lips are trapped in a cocksucking pout. Her breasts are loveably huge and her hips sway with the confidence that only befit a woman with an ass that could end wars. Deep purple eyes peer out from a frame of obsidian skin, topped with braided white hair.

“You’d think they’d be smart enough to avoid abduction zones, instead of be drawn to them like flies. Why did you look for us?”

She steps closer and every alarm in your body ratchets up another level. She smiles casually and throws her arms up in to the air as though conducting an orchestra. The Beast by your side is dispersed like dust on the wind and your alarm turns to full blown panic. Without your UI you’re all but trapped on this server.

It’s almost unheard of by this point, but before you can form a coherent sentence her hands are threaded through your hair, and you’re pulled in close to her. She kisses you hard, tongue wrestling with yours as she explores every taste your mouth has to offer.

She pulls back, and when you gasp for air you didn’t know you needed, she’s licking her lips. “Much better. It’s just you, and me”. She pushes you to the ground and drops to all fours, crawling towards you. She grips at your clothing and pulls her hands apart. Instead of removing it, you’re rendered immediately naked. Her eyes bore into yours and she takes your manhood in a surprisingly soft grip. After a few jerks, any attempt at speech is rendered impossible in a series of groans.

The parts of you that should be saying this is impossible are suppressed as she crouches down. Her womanhood is brushing over the hardness of your cock, clear against the tightness of her bodysuit. You bite down hard on your lip, trying to process anything at all.

She grinds, just once, a single confident motion from the base of your lance to the tip, and your body gives in, painting her cunt and thighs ivory with your seed. You gasp desperately for breath, and the edges of your vision begin to blur. The woman only coos above you. Purple eyes that judge every inch of your digital body cast up and down you. She stands up, hand wiping spunk from skintight clothing.

“Over so soon!! Not that I’m surprised, you look a little… Off guard. That’s dangerous, did nobody ever teach you to defend yourself?” she asks, licking her hand. “Good luck on the other side” she says.

You’ve never been forced out of the digital world before, but you find yourself in meatspace, sprawled on the floor away from your computer, clothes shamefully sticky. The net jack behind your ear feels hot enough to burn and you’re trying exceptionally hard not to just throw up.

Your door is kicked viciously open, but the sound seems muted, and you’re fairly sure you’re blacking out. Maybe you hit your head. Two suited men walk in and scoop you up by the arms and legs. You’re unsure, but you think one of them apologises.

And then nothingness.'.
	femaleScene2Node := StoryNode
		text:
			'Ah the faithful dog. Resilient and loyal. You slide a cord from the side of your computer, stroking the jack with your fingers. You take a soft breath, holding it in. It’s always felt like this, deep down inside; a churning in your stomach right before you hook up.

The moment the jack of the cord meets the one behind your ear, your hands fall into your lap. The breath you hold escapes in a yawn as you sink into the warm embrace of data. Your body grows warm, and the churning in your stomach settles to a calm sea.

You open eyes you didn’t even realise had even closed, and look about yourself. All around is the architecture of your computer; it always looks like a richly furnished lounge, surrounded by obelisks of processing and data. It has always felt like your real home; your fortress.

You feel that fortress look you over, cautiously. That’s your own fault; you made sure to keep the Beast paranoid. You don’t always encounter the friendliest types when you make a living hacking big scary corps. After a few moments, a door opens, and you feel yourself being pulled inside like an old friend who hasn’t visited in months.

You could start some games from here, but there’s only one thing you’re really interested in doing in your time off.

You feel a presence at your feet, and crouch, hands spreading wide. A jet black Husky dog all but pounces on you, licking at your neck. It feels real enough, every sensation of your body is cranked up to eleven when you’re jacked into a computer. After a little, the dog settles back, wolfy features and eyes quite literally glowing with intelligence.

“Welcome back Master” it seems to say, the words echoing in your head with warmth. You grin and point at a door, and the Beast pads its way over, tail wagging.

“We’re going for a walkies” you say proudly. It’s a joke you never get tired of telling. The door seems to sit at the end of your lounge, and it’s the entrance to the net itself. It’s impossible to traverse with just your own intelligence. Humans aren’t made to cope with that density of information. Once you’re on a server it’s no problem, you can adjust. But in order to get from one to the other. You need a companion.

You smile fondly at the Beast, opening the door and jumping in to the white light that shines out. The Beast follows after you, leaping into the opening. For a brief, panic-ridden moment you’re afloat in a cascade of numbers. But you feel the invisible leash of your companion around your wrist, and the world goes still.

Instead there are tunnels, tunnels to endless possibilities. At the speed of thought you’re hurtling down tubes connected to polyhedrons of various faces. You take the familiar bookmarked routes, and the white light swaps to a pitch blackness. It used to be scary, but you’ve done it so often it’s even easier than breathing.

You jump through a few proxies, and in what feels like a minute on the net, you know only seconds have passed in reality. You reach the next proxy and pause. You can feel it deep down, and the Beast confirms it. You press your hands against a sheet black surface, like polished obsidian in a tunnel of nothing. 

Your entire body seems to glitch as you lag for the barest few moments. Your breath catches, and then  a crack spreads in the wall. You knock, it’s only polite, and the wall shatters, turning into a door that you step through, the Beast on your heels.

And now you’re in the hub of humanity’s greatest depravities. Heck, by this point you’ve probably taken part in most of them.

What looks like a man of twenty, with the ears of a dog, steps out in front of you.

“Greetings sir, do you have a login?”

You’re a little caught off guard, and stumble, back. But you confirm that you do, and a moment later the man grins. His official demeanour slips as his own UI likely confirms you, and you even catch the hint of a tail wagging.

“Cheers buddy. I hate playing strongarm. I know, I know. This is no Light-net authenticated user bollocks, but there’ve been some weird sorts about”

You look around, and watch twenty mice pour out of a casino, before bursting into flames. Nooby hackers never learn. The dogman follows your gaze and chuckles.

“I know!! Weird even for here. But seriously, I mean it. I hear we’ve got Pirates. And not the kind that can score raunchy flicks, but the Black-Ops information hustling kind. Rumour says they’ve even got some dudes working in meatspace ganking anyone who tries to figure them out. So yeah, authenticated people only for now, we don’t need that kinda flak”.

You’re about to ask him for more information, but the Dog-Man’s ears twitch, and you hear a pinging noise.

“Sorry buddy, gotta bounce. There’s a sexy slice of puss with this pup’s name on it”

He waves apologetically and scampers off. Next stop, you suppose. You take a moment to look over the whole hub. It’s a central point for people on the Dark Net. a Corporation-free haven for the info-trade. Well, mostly corp free. You know they’ve got men on the inside, but you’ve yet to meet one.

On the net your body has needs, and can feel all the sensations. There’s no end of sex-trade, alcohol-drinking, and monster fighting to get up to. Sometimes they’re all the same at once, the Dark Net gets pretty dangerous. You head towards an information board and look up news on these new Pirates though.

It takes a little browsing, most of the information is bunk rumour-mongering, but this is the kind of thing you’re trained in taking apart. Eventually you find a node that’s seen a lot more action. You find a proxy door, and head out, with the Beast at your side.

Instead of another hub town, you find yourself with an open field. You’re sure this isn’t right, you were looking for some kind of base of operations, or at the least a busy info-bar. But this is a straight-up fantasy field.

“Oi!!” calls a thickly accented voice.

Your Beast growls, hackles rising. You turn to meet the voice, already thinking of ways to defend yourself. Instead of some kind of poorly dressed internet-pirate, you’re faced with a stunning visage in a black skintight bodysuit. Your brain almost can’t register their gender but the mere sight of them sends your sex drive skyrocketing in to uncontrollable heights.'.
	femaleScene3Node := StoryNode 
		text: 'It’s a guy, it couldn’t be anything but a guy. His skin is of purest obsidian, his ears are elfin, and though his features are feminine, you can see the bulge against his pants. There must be eight inches of the monster there, and your eyes are caught between staring at it or being lost in the stranger’s own eyes.

He sighs, walking towards you. You try to take a step back but your body refuses to play along. He waves and speaks up “Ah!! Another one I see, perhaps you’ll be more entertaining”.

He casts his hands wide and The Beast at your side is suddenly dispersed like dust in the wind. Your worry is sent into a full blown panic, and your limbs refuse to take commands, stuck as though held fast in cement. The only thing you can feel is a growing heat in your crotch, moisture running down the inside of your leg. It almost tickles but you can’t do anything about it.

“Much better, just you and me” he says. You blink, and when your eyes open his hands are on your cheeks, holding your face fast when you try to flinch. Shining purple eyes bore into you, and the man looks down. He grins and grabs you chest roughly, giving your tits a squeeze.

You gasp and nearly bite down on your tongue, he gives your nipples a flick that leaves them harder than diamonds, and his hands travel down to your pants. Instead of tug them off however, he just pulls them apart with as much effort as he would with tissue paper. Your bare soaking slit is assaulted roughly by his fingers, which are immediately soaked with your excitement. His thumb grinds on your clit and your body feels like it’s exploding, a helpless squirt of girlcum soaking his hand as he pushes you to the ground.

You see the world begin to grow dark around the edges as the man licks his hand clean, smirking. “That’s too bad, still, amusing enough. Good luck on the other side”.

Before you can ask what he means, you feel yourself being vigorously booted out of the net, when your eyes open, you’re sprawled out helplessly on the floor, the net jack behind your ear is burning hot. You pant for breath and fight back the sensation of nausea.

Your door is blasted open with a forceful kick, but you’re able to do little more than wriggle on the floor, legs damp with cooling excitement as you begin to black out for real. Two suited figures pick you up, one of them mutters you a gentle “Sorry”.'.
	femaleScene4Node := StoryNode 
		text: 'It’s a woman. It couldn’t be anything but. She must have double F cups and her lips are trapped in a cocksucking pout. Her breasts are loveably huge and her hips sway with the confidence that only befit a woman with an ass that could end wars. Deep purple eyes peer out from a frame of obsidian skin, topped with braided white hair.

“You’d think they’d be smart enough to avoid abduction zones, instead of be drawn to them like flies. Why did you look for us?”

She steps closer and every alarm in your body ratchets up another level. She smiles casually and throws her arms up in to the air as though conducting an orchestra. The Beast by your side is dispersed like dust on the wind and your alarm turns to full blown panic. Without your UI you’re all but trapped on this server.

It’s almost unheard of by this point, but before you can form a coherent sentence her hands are threaded through your hair, and you’re pulled in close to her. She kisses you hard, tongue wrestling with yours as she explores every taste your mouth has to offer.

She pulls back, and when you gasp for air you didn’t know you needed, she’s licking her lips. “Much better. It’s just you, and me”. She pushes you to the ground and drops to all fours, crawling towards you. She grips at your clothing and pulls her hands apart. Instead of removing it, you’re rendered immediately naked.

You feel the heat in you begin to flow immediately to your nethers, pussy growing soaked as you feel dreadlocks tickle their way up your thighs. The woman looks up at you over the crest of your tits, grinning wickedly. Then she blows you a kiss as her hand takes you, penetrating you hard, her thumb grinding a circle around your clit that fills your mind with sparks.

What must only have been a moment feels like forever as you soak yourself, coming hard on her hand at such a small amount of movement. The woman wipes her hand off on your thigh, standing up and licking off whatever seems to remain.

“You’re going to have to look in to some real protection if you want to go hunting for the big players. But sadly our time here is up. Good luck on the other side, we may meet again soon”.

You try to speak, but it feels like your tongue has been plastered to the roof of your mouth. You feel existence crunch up on itself as you’re booted viciously out of the net. You’re sprawled out on the floor of meatspace like a discarded doll with soaked panties, too nauseated to move.

You can barely hear the door to your home being kicked open as your consciousness starts to wink out. Two suited figures step on either side of you and pick you up by arms and legs. One of them quietly apologises before the blackness takes you.'.
	theEndNode := StoryNode
		text:
			'Thanks for taking part in version 0.1, coming soon will be the release of a real RPG UI. And more story, and options, with maps and towns to explore, and people to see, places to be, monsters to fight, and people and monsters to fuck.'.	
				
	map
		addStoryNode: introductionNode;
		addStoryNode: genderMaleNode;
		addStoryNode: genderFemaleNode;
		addStoryNode: maleScene1Node;
		addStoryNode: femaleScene1Node;
		addStoryNode: maleScene2Node;
		addStoryNode: femaleScene2Node;
		addStoryNode: maleScene3Node;
		addStoryNode: femaleScene3Node;
		addStoryNode: maleScene4Node;
		addStoryNode: femaleScene4Node;
		addStoryNode: theEndNode;
		startStoryOn: introductionNode.	
			
	map fromNode: introductionNode youCan: 'Male' andGoTo: genderMaleNode.
	map fromNode: introductionNode youCan: 'Female' andGoTo: genderFemaleNode.
	map fromNode: genderMaleNode youCan: 'Toned' andGoTo: maleScene1Node.
	map fromNode: genderMaleNode youCan: 'ComingSoon' andGoTo: maleScene1Node.
	map fromNode: genderFemaleNode youCan: 'Curvy' andGoTo: femaleScene1Node.
	map fromNode: genderFemaleNode youCan: 'ComingSoon' andGoTo: femaleScene1Node.
	map fromNode: maleScene1Node youCan: 'Dog' andGoTo: maleScene2Node.
	map fromNode: maleScene1Node youCan: 'ComingSoon' andGoTo: maleScene2Node.
	map fromNode: femaleScene1Node youCan: 'Dog' andGoTo: femaleScene2Node.
	map fromNode: femaleScene1Node youCan: 'ComingSoon' andGoTo: femaleScene2Node.
	map fromNode: maleScene2Node youCan: 'Guy' andGoTo: maleScene3Node.
	map fromNode: femaleScene2Node youCan: 'Guy' andGoTo: femaleScene3Node.
	map fromNode: maleScene2Node youCan: 'Girl' andGoTo: maleScene4Node.
	map fromNode: femaleScene2Node youCan: 'Girl' andGoTo: femaleScene4Node.
	map fromNode: maleScene3Node youCan: 'ComingSoon' andGoTo: theEndNode.
	map fromNode: femaleScene3Node youCan: 'ComingSoon' andGoTo: theEndNode.
	map fromNode: maleScene4Node youCan: 'ComingSoon' andGoTo: theEndNode.
	map fromNode: femaleScene4Node youCan: 'ComingSoon' andGoTo: theEndNode.
	^ map.! !

!StoryMap class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 06:42'!
example
	| mapa nodoComienzo nodoFinal |
	
	mapa := StoryMap new.
	nodoComienzo := StoryNode text: 'Welcome to the game. It''s super hot. Wear mittens!!'.
	nodoFinal := StoryNode
		text: 'You''ve won the game. You should be proud. We hope you enjoyed the lack of any erotic content.'.
	mapa
		addStoryNode: nodoComienzo;
		addStoryNode: nodoFinal;
		startStoryOn: nodoComienzo.
	mapa fromNode: nodoComienzo youCan: 'Win!!' andGoTo: nodoFinal.
	^ mapa.! !

!StoryMap methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/1/2015 07:44'!
addStoryNode: aStoryNode 
	self nodes add: aStoryNode.! !

!StoryMap methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:04'!
beginning
	^ beginning.! !

!StoryMap methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 07:59'!
fromNode: originNode youCan: aString andGoTo: destinationNode 
	self nodes addIfNotPresent: originNode; addIfNotPresent: destinationNode.
	self transitions add: (StoryTransition origin: originNode destination: destinationNode actionDescription: aString).! !

!StoryMap methodsFor: 'accessing' stamp: 'FedericoFigueredo 6/1/2015 08:08'!
initialize
	nodes := OrderedCollection new.
	transitions := OrderedCollection new.! !

!StoryMap methodsFor: 'accessing' stamp: 'FedericoFigueredo 6/1/2015 07:49'!
nodes
	^ nodes.! !

!StoryMap methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/1/2015 07:59'!
startStoryOn: aStoryNode 
	self nodes addIfNotPresent: aStoryNode.
	beginning := aStoryNode.! !

!StoryMap methodsFor: 'acessing' stamp: 'FedericoFigueredo 6/1/2015 08:08'!
transitions
	^ transitions.! !

!StoryMap methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 07:24'!
transitionsFrom: aStoryNode 
	^ self transitions select: [ :each | each origin = aStoryNode ].! !

Object subclass: #StoryMapHtmlRenderer
	instanceVariableNames: 'filesystem outputDirectory htmlName storyMap enumeratedNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!StoryMapHtmlRenderer commentStamp: 'SergioFedi 6/5/2015 23:33' prior: 0!
I render a StoryMap in several files.
Among these files there will be a main html file which you can browse statically to navigate the StoryMap.!

!StoryMapHtmlRenderer methodsFor: 'public' stamp: 'FedericoFigueredo 6/17/2015 07:15'!
enumerateNodes

enumeratedNodes := Dictionary new.

storyMap nodes
		with: (1 to: storyMap nodes size)
		do: [:node :index |
			enumeratedNodes at: node put: index.
		].
! !

!StoryMapHtmlRenderer methodsFor: 'accessors' stamp: 'SergioFedi 6/6/2015 00:29'!
filesystem
	filesystem isNil ifTrue: [ filesystem := FileSystem workingDirectory ].
	^ filesystem! !

!StoryMapHtmlRenderer methodsFor: 'accessors' stamp: 'SergioFedi 6/5/2015 23:38'!
filesystem: aFileSystem 
	filesystem := aFileSystem.! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 6/6/2015 10:43'!
htmlFileContentsForNode: aStoryNode withTransitions: transitions

	^WAHtmlCanvas builder 
	fullDocument: false;
	render: [ :html |
		self renderNode: aStoryNode from: storyMap on: html]! !

!StoryMapHtmlRenderer methodsFor: 'accessors' stamp: 'SergioFedi 6/5/2015 23:41'!
htmlName: aString 
	htmlName := aString .! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 6/23/2015 07:21'!
mainHtmlFileContents

	| doc ctx root html |
	^String streamContents: [ :stream |
	    doc := WAHtmlDocument on: stream.
	    ctx := WARenderContext new document: doc.
	    root := WAHtmlRoot new.
		 root setContext: ctx.
	    self rootBlock value: root.
	    root writeHeadOn: doc.
	    html := WAHtmlCanvas new initializeWithContext: ctx.
	    self renderBlock value: html.
	    root writeFootOn: doc ].

"
	^ WAHtmlCanvas builder
		fullDocument: true;
		rootBlock: self rootBlock;
		render: self renderBlock
"! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 6/6/2015 11:04'!
mainStoryDivId
	^ 'mainStoryNode'! !

!StoryMapHtmlRenderer methodsFor: 'accessors' stamp: 'SergioFedi 6/5/2015 23:39'!
outputDirectory: aString 
	outputDirectory := aString.! !

!StoryMapHtmlRenderer methodsFor: 'public' stamp: 'FedericoFigueredo 6/17/2015 07:13'!
render

	filesystem ensureCreateDirectory: outputDirectory.
	self enumerateNodes.
	self renderMainHtmlFile.
	self renderStoryNodes.! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 6/22/2015 07:32'!
renderBlock
	^ [ :html | 
	html div 
		class: 'container';
		with:
		[	html heading level1 with: 'Story Map'.
			html div
				id: self mainStoryDivId;
				class: 'storyNode';
				with: [ :html2 | self renderFirstNodeFrom: storyMap on: html2 ].
			html script with: 'function onLoad(){
				installNavigationFunctionality();
			};'.
		]
	].
! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 6/6/2015 10:41'!
renderFirstNodeFrom: aStoryMap on: html 

	self renderNode: aStoryMap beginning from: aStoryMap on: html.! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 6/6/2015 10:19'!
renderMainHtmlFile

	| htmlFile |
	htmlFile := filesystem writeStreamOn: outputDirectory, filesystem separator asString, htmlName, '.html'.
	htmlFile nextPutAll: self mainHtmlFileContents.
	htmlFile close.! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 6/18/2015 06:47'!
renderNode: aStoryNode from: aStoryMap on: html 
	
	| transitions |
	transitions := aStoryMap transitionsFrom: aStoryNode.
	html div
		class: 'nodeText';
		with: [
			aStoryNode paragraphs do: [:paragraph |
				html paragraph with: paragraph.
			]
		].
	html div
		class: 'actions';
		with: [
			transitions do: [:transition | 
				| anchor  htmlNodeName |
				anchor := html anchor.
				htmlNodeName := htmlName, '_node_', (enumeratedNodes at: transition destination) asString, '.html'.
				anchor class: 'action'.
				anchor attributes at: 'htmlReference' put: htmlNodeName.
				anchor with: transition actionDescription.
			]
		].! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 6/23/2015 07:20'!
renderScriptsOn: root

	root script
		url: 'lib/jquery-1.11.2.min.js'.
	root script
		url: 'lib/smuttyFunctions.js'.
	"root addScript: 'function onLoad(){
		installNavigationFunctionality();
	};'."
! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'FedericoFigueredo 6/17/2015 07:29'!
renderStoryNodes

	enumeratedNodes associationsDo: 
		[:association |
			| htmlFile node index |
			node := association key.
			index := association value.
			
			htmlFile := filesystem writeStreamOn:
				outputDirectory, 
				filesystem separator asString, 
				htmlName, 
				('_node_{1}.html' format: index asOrderedCollection).
			htmlFile nextPutAll: (self htmlFileContentsForNode: node withTransitions: (storyMap transitionsFrom: node)).
			htmlFile close.
		].! !

!StoryMapHtmlRenderer methodsFor: 'private' stamp: 'SergioFedi 6/22/2015 06:45'!
rootBlock
					
	^[ :root |
			root 
				title: 'Story Map Render';
				beHtml5.
			root stylesheet url: 'css/testStory.css'.
			root
				meta charset: 'utf-8'.
			self renderScriptsOn: root.
	].
		! !

!StoryMapHtmlRenderer methodsFor: 'accessors' stamp: 'SergioFedi 6/5/2015 23:42'!
storyMap: aStoryMap 
	storyMap := aStoryMap .! !

Object subclass: #StoryMapMarkdownRenderer
	instanceVariableNames: 'storyMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web'!

!StoryMapMarkdownRenderer class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/18/2015 08:06'!
on: aStoryMap 
	^ self new storyMap: aStoryMap.! !

!StoryMapMarkdownRenderer methodsFor: 'public' stamp: 'FedericoFigueredo 6/19/2015 07:41'!
render
	| stream nodes |
	stream := WriteStream on: String new.
	nodes := storyMap nodes.
	
	nodes do: 
		[ :node | stream 
		nextPutAll: '# Name', (nodes indexOf: node) asString;
		cr;
		nextPutAll: node text;
		cr.
		(storyMap transitionsFrom: node) do: [ :transition | stream 
			cr;
			nextPut: $[; 
			nextPutAll: transition actionDescription;
			nextPut: $];
			nextPut: $(;
			nextPutAll: 'Name', (nodes indexOf: transition destination) asString;
			"Después hacemos algo tipo | nextPutAll: transition destination name;"
			nextPut: $);
			yourself.]
		]
		separatedBy: [ stream cr; cr ].
		
	^ stream contents.! !

!StoryMapMarkdownRenderer methodsFor: 'accessors' stamp: 'FedericoFigueredo 6/18/2015 08:07'!
storyMap: aStoryMap 
	storyMap := aStoryMap.! !

Object subclass: #StoryNode
	instanceVariableNames: 'text paragraphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!StoryNode commentStamp: 'SergioFedi 6/5/2015 20:41' prior: 0!
I model a specific point in the story space.
For example, the beginning of a story is an instance of me.
So are the different endings.!

!StoryNode class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/1/2015 07:38'!
text: aString 
	^ self new text: aString.! !

!StoryNode methodsFor: 'accessors' stamp: 'SergioFedi 6/18/2015 06:28'!
paragraphs

	^paragraphs.! !

!StoryNode methodsFor: 'accessors' stamp: 'SergioFedi 6/18/2015 06:41'!
paragraphs: aCollection 
	paragraphs := aCollection! !

!StoryNode methodsFor: 'accessors' stamp: 'SergioFedi 6/6/2015 00:17'!
text
	^ text! !

!StoryNode methodsFor: 'setter' stamp: 'SergioFedi 6/18/2015 06:52'!
text: aString 
	text := aString.
	self paragraphs: (aString 
		findBetweenSubStrs: (Array with: Character cr with: Character cr) asArray).! !

Object subclass: #StoryTransition
	instanceVariableNames: 'origin destination actionDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!StoryTransition commentStamp: 'SergioFedi 6/5/2015 20:42' prior: 0!
I model a change from one StoryNode to another.
This includes the origin, destination and what makes the change.!

!StoryTransition class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/3/2015 08:03'!
origin: aStoryNode destination: aStoryNode2 actionDescription: aString 
	^ self new
		origin: aStoryNode; 
		destination: aStoryNode2; 
		actionDescription: aString.		! !

!StoryTransition methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 08:02'!
actionDescription
	^ actionDescription.! !

!StoryTransition methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 08:03'!
actionDescription: aString 
	actionDescription := aString.! !

!StoryTransition methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:25'!
destination
	^ destination.! !

!StoryTransition methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/2/2015 06:29'!
destination: aStoryNode 
	destination := aStoryNode.! !

!StoryTransition methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:24'!
origin
	^ origin.! !

!StoryTransition methodsFor: 'setter' stamp: 'FedericoFigueredo 6/2/2015 06:27'!
origin: aStoryNode 
	origin := aStoryNode.! !
